#define BOUND 15
#define ACC_LOWER 16
#define ACC_UPPER 250
#define TRIGGER_LOWER 10
#define TRIGGER_UPPER 150
#define CALIBRATE 60
#define KEY 17052013ul

#include <stdint.h>
#include "hal/acc.h"
#include "hal/hal.h"
#include "hal/key.h"
#include "hal/timer.h"
#include "hal/rc.h"
#include "hal/trigger.h"

int main(){

	
	uint8_t timer_started = 0;
	uint8_t unlocked = 0;
	
	init();
	
	rc_off();
	acc_set_offset();
	
	/* Some kind of state machine. Not very well documented… */
	
	while(1){
	
		if(key_submitted(KEY)){
			
			rc_off();
			unlocked = 1;
			timer_start();
			timer_started = 0;
		}
	
		if(unlocked){
			
			if(timer_get() > CALIBRATE){
				
				timer_stop();
				unlocked = 0;
				acc_set_offset();
			}
		}
		else{
		
			if(triggered()){
				
				if(!timer_started){
					
					/* Ignore single spikes */
					
					timer_start();
					timer_started = 1;
				}
				else{
				
					if(timer_get() < TRIGGER_UPPER && timer_get() > TRIGGER_LOWER){
					
						rc_on_D();
						timer_stop();
						timer_started = 0;
					}
				}		
			}
		
			if(acceleration() > BOUND){
			
				if(!timer_started){
				
					/* Ignore single spikes */
					
					timer_start();
					timer_started = 1;
				}
				else{
				
					if(timer_get() < ACC_UPPER && timer_get() > ACC_LOWER){
					
						rc_on_D();
						timer_stop();
						timer_started = 0;
					}
				}		
			}
		
			if(timer_started && timer_get() >= TRIGGER_UPPER && timer_get() >= ACC_UPPER){
			
				timer_stop();
				timer_started = 0;
			}
		}
	}
	
	return 0;
}

