/*
	
	Acceleration measurement related things.
	
*/

#include <stdint.h>

#define F_CPU 8000000ul
#include <util/delay.h>


volatile uint16_t offset[3];
extern volatile uint16_t adc[4];


uint16_t dist(uint16_t x, uint16_t y){
	
	return (x > y) ? x - y : y - x;
}

void acc_set_offset(){
/*
	Saves recent acceleration into offset array.
*/
	
	_delay_ms(50);
	
	offset[0] = adc[0];
	offset[1] = adc[1];
	offset[2] = adc[2];
}

uint16_t acceleration(){
/*
	Returns the 1-norm of the difference between recent acceleration and
	saved offset.
*/	
	
	return dist(adc[0], offset[0]) + dist(adc[1], offset[1]) + dist(adc[2], offset[2]);
}


