/*
	
	Gives access to remote control with to channels.
	
*/

#include <avr/io.h>

#define F_CPU 8000000ul
#include <util/delay.h>


void rc_init(){
	
	DDRD |= (1 << PD0) | (1 << PD1) | (1 << PD2) | (1 << PD3);
}

void rc_on_C(){
	
	PORTD |= (1 << PD1) | (1 << PD3);
	_delay_ms(200);
	PORTD &= ~((1 << PD1) | (1 << PD3));
}

void rc_off_C(){
	
	PORTD |= (1 << PD2) | (1 << PD3);
	_delay_ms(200);
	PORTD &= ~((1 << PD2) | (1 << PD3));
}

void rc_on_D(){
	
	PORTD |= (1 << PD1) | (1 << PD0);
	_delay_ms(200);
	PORTD &= ~((1 << PD1) | (1 << PD0));
}

void rc_off_D(){
	
	PORTD |= (1 << PD2) | (1 << PD0);
	_delay_ms(200);
	PORTD &= ~((1 << PD2) | (1 << PD0));
}

void rc_off(){
	
	rc_off_C();
	rc_off_D();
}

void rc_on(){
	
	rc_on_C();
	rc_on_D();
}

