/*
	
	Simple timer (stopwatch) utility.
	
*/

#include <stdint.h>

#include <avr/io.h>
#include <avr/interrupt.h>


volatile uint16_t timer;


void timer_init(){
	
	/* Enable overflow interrupts */
	TIMSK2 |= (1 << TOIE2);
}

void timer_start(){
	
	/* Prescaler 1024 */
	
	TCCR2B |= (1 << CS22) | (1 << CS21) | (1 << CS20);
	timer = 0;
}

void timer_stop(){
	
	/* Stop timer */
	
	TCCR2B &= ~((1 << CS22) | (1 << CS21) | (1 << CS20));
}

uint16_t timer_get(){
	
	return timer;
}


ISR(TIMER2_OVF_vect){

	if(timer < 0xffff){
		
		++timer;
	}
}
