#include <avr/io.h>


void trigger_init(){
	
	/* yellow, brown and GND (cable) to GND */
	DDRB |= (1 << PB0) | (1 << PB6);
	DDRD |= (1 << PD6);
	
	/* Pullup for pink, green and white */
	PORTD |= (1 << PD7) | (1 << PD4) | (1 << PD5);
}

uint8_t triggered(){
	
	if(PIND & (1 << PD7)){
	
		/* Primary Trigger */
		return 1;
	}
	
	if(!(PIND & (1 << PD4))){
	
		/* Cable cut?! */
		return 1;
	}
	
	if(PIND & (1 << PD5)){
	
		/* GND shield broken */
		return 1;
	}
	
	return 0;
}
